/*
 * Model.java
 *
 * Created on September 13, 2000, 1:23 PM
 */
 
package saaps.ann;

/** 
 *
 * @author  saaps
 * @version 
 */
public abstract class Model extends Object {

  // An environment property to define the path to the models.
  public static String modelDirVar="saaps.models";
  
  //The neural network.
  private Network net;
  
  //The input data.
  private Data input;
  
  //The output data.
  private Data output;
  
  //A calendar object for time computations.
  private Calendar calendar;

  /** Creates new Model */
  public Model() {
  }
  
  private void initCalendar()
  {
    calendar.getInstance(TimeZone.getTimeZone("GMT"));
  }
  
  protected abstract void createNetwork();
  
  protected abstract void normalize();
  
  protected abstract void timeSeriesToData();
  
}
