/*
 * NetworkTest.java
 *
 * Created on August 10, 2000, 8:37 PM
 */
 
package saaps.ann.mlff;

import saaps.ann.*;

/** 
 *
 * @author  saaps
 * @version 
 */
public class NetworkTest extends Object {

  /** Creates new NetworkTest */
  public NetworkTest() {
  }
  
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    //Two layers.
    Layer[] layers = new Layer[2];
    
    //First layer: 4 inputs, 3 neurons (outputs).
    Weights[] w1 = WeightsCreator.read("/space/saaps/w1.text",4);
    TanhNeuron[] n1 = new TanhNeuron[3];
    for (int i=0;i<n1.length;i++)
      n1[i] = new TanhNeuron(w1[i]);
    layers[0] = new Layer(n1);
    
    //Second layer: 3 inputs and 2 neurons.
    Weights[] w2 = WeightsCreator.read("/space/saaps/w2.text",3);
    TanhNeuron[] n2 = new TanhNeuron[2];
    for (int i=0;i<n2.length;i++)
      n2[i] = new TanhNeuron(w2[i]);
    layers[1] = new Layer(n2);
    
    //Create network.
    Network net = new Network(layers);
    
    //Get the input data.
    Data input = DataCreator.read("/space/saaps/input.text",4);
    net.setInput(input);
    Data output = net.getOutput();
    System.out.println("Input data");
    input.print();
    System.out.println("Output data");
    output.print();
  }

}