/*
 * ExportAsciiFrame.java
 *
 * Created on June 5, 2001, 9:17 PM
 */

package saaps.dbt;

import java.awt.*;
import java.io.IOException;
import java.text.DecimalFormat;
//import java.text.NumberFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Vector;

import saaps.util.InfoDialog;
import saaps.util.AppHelp;
import saaps.util.TextFieldException;
import saaps.saam.ErrorDialog;

import saaps.dbt.ODIDatabase;
import saaps.dbt.DatabaseItems;

/**
 *
 * @author  root
 * @version 
 */
public class ExportAsciiFrame extends java.awt.Frame {
    //An object to the ODI database.
    private ODIDatabase odiDatabase;
    
    //A calendar object to do time computation.
    private Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));

    //Help
    private AppHelp help=null;

    private static ErrorDialog ed = null;
    
    /** Creates new form ExportAsciiFrame */
    public ExportAsciiFrame() {
        this.initComponents();
	this.odiDatabase = new ODIDatabase();
        this.initListDatabaseItems();
        pack();
    }
    
    private void initListDatabaseItems() {
        //Get the database items.
//        Vector items = DatabaseItems.list();
        Vector items = odiDatabase.listDataset();
        //Create the list.
        for (int i=0;i<items.size();i++) {
            this.listDatabaseItems.add((String)((Vector)items.elementAt(i)).elementAt(1));
//            this.listDatabaseItems.add((String) items.elementAt(i));
        }
    }
    
    private Date parseStartDate() {
        return this.parseDate(this.textFieldStartYear,
        this.textFieldStartMonth,
        this.textFieldStartDate,
        this.textFieldStartHour,
        this.textFieldStartMinute);
    }
    
    private Date parseEndDate() {
        return this.parseDate(this.textFieldEndYear,
        this.textFieldEndMonth,
        this.textFieldEndDate,
        this.textFieldEndHour,
        this.textFieldEndMinute);
    }
    
    private Date parseDate(TextField year, TextField month, TextField date, TextField hour, TextField minute) {
        this.cal.set(Calendar.YEAR,Integer.parseInt(year.getText()));
        this.cal.set(Calendar.MONTH,Integer.parseInt(month.getText())-1);
        this.cal.set(Calendar.DATE,Integer.parseInt(date.getText()));
        this.cal.set(Calendar.HOUR_OF_DAY,Integer.parseInt(hour.getText()));
        this.cal.set(Calendar.MINUTE,Integer.parseInt(minute.getText()));
        return this.cal.getTime();
    }
    
    /**
     * Checks the input fields for correct input.
     * @return true when fields are not ok
     */
    private void verifyInputFields() throws TextFieldException {
        try {
	    Integer.valueOf(this.textFieldStartYear.getText());
	    Integer.valueOf(this.textFieldStartMonth.getText());
	    Integer.valueOf(this.textFieldStartDate.getText());
	    Integer.valueOf(this.textFieldStartHour.getText());
	    Integer.valueOf(this.textFieldStartMinute.getText());
	    Integer.valueOf(this.textFieldEndYear.getText());
	    Integer.valueOf(this.textFieldEndMonth.getText());
	    Integer.valueOf(this.textFieldEndDate.getText());
	    Integer.valueOf(this.textFieldEndHour.getText());
	    Integer.valueOf(this.textFieldEndMinute.getText());
        }
        catch (NumberFormatException e) {
            throw new TextFieldException("Please use integer for time fields.\n");
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelExport = new java.awt.Panel();
        buttonExport = new java.awt.Button();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        panelDatabaseItems = new java.awt.Panel();
        labelDatabaseItems = new java.awt.Label();
        listDatabaseItems = new java.awt.List();
        buttonInspect = new java.awt.Button();
        panel4 = new java.awt.Panel();
        panel5 = new java.awt.Panel();
        label3 = new java.awt.Label();
        panelStartDate = new java.awt.Panel();
        label4 = new java.awt.Label();
        textFieldStartYear = new java.awt.TextField();
        label6 = new java.awt.Label();
        textFieldStartMonth = new java.awt.TextField();
        label7 = new java.awt.Label();
        textFieldStartDate = new java.awt.TextField();
        label8 = new java.awt.Label();
        textFieldStartHour = new java.awt.TextField();
        label9 = new java.awt.Label();
        textFieldStartMinute = new java.awt.TextField();
        panel6 = new java.awt.Panel();
        label1 = new java.awt.Label();
        panelEndDate = new java.awt.Panel();
        label2 = new java.awt.Label();
        textFieldEndYear = new java.awt.TextField();
        label5 = new java.awt.Label();
        textFieldEndMonth = new java.awt.TextField();
        label10 = new java.awt.Label();
        textFieldEndDate = new java.awt.TextField();
        label11 = new java.awt.Label();
        textFieldEndHour = new java.awt.TextField();
        label12 = new java.awt.Label();
        textFieldEndMinute = new java.awt.TextField();
        
        setLayout(new java.awt.BorderLayout(10, 0));
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panelExport.setFont(new java.awt.Font("Dialog", 0, 11));
        panelExport.setName("panel6");
        panelExport.setBackground(new java.awt.Color(204, 204, 204));
        panelExport.setForeground(java.awt.Color.black);
        buttonExport.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonExport.setLabel("Export ...");
        buttonExport.setName("button14");
        buttonExport.setBackground(new java.awt.Color(204, 204, 204));
        buttonExport.setForeground(java.awt.Color.black);
        buttonExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonExportActionPerformed(evt);
            }
        });
        
        panelExport.add(buttonExport);
        
        buttonHelp.setLabel("Help");
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelExport.add(buttonHelp);
        
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button15");
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelExport.add(buttonQuit);
        
        add(panelExport, java.awt.BorderLayout.SOUTH);
        
        panelDatabaseItems.setLayout(new java.awt.BorderLayout());
        
        panelDatabaseItems.setFont(new java.awt.Font("Dialog", 0, 11));
        panelDatabaseItems.setName("panel11");
        panelDatabaseItems.setBackground(new java.awt.Color(204, 204, 204));
        panelDatabaseItems.setForeground(java.awt.Color.black);
        labelDatabaseItems.setFont(new java.awt.Font("Dialog", 0, 11));
        labelDatabaseItems.setName("label5");
        labelDatabaseItems.setBackground(new java.awt.Color(204, 204, 204));
        labelDatabaseItems.setForeground(java.awt.Color.black);
        labelDatabaseItems.setText("Database Items");
        panelDatabaseItems.add(labelDatabaseItems, java.awt.BorderLayout.NORTH);
        
        listDatabaseItems.setFont(new java.awt.Font("Dialog", 0, 11));
        listDatabaseItems.setName("list5");
        listDatabaseItems.setBackground(new java.awt.Color(255, 247, 233));
        listDatabaseItems.setForeground(java.awt.Color.black);
        listDatabaseItems.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listDatabaseItemsItemStateChanged(evt);
            }
        });
        
        panelDatabaseItems.add(listDatabaseItems, java.awt.BorderLayout.CENTER);
        
        buttonInspect.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonInspect.setLabel("Show MetaData");
        buttonInspect.setName("button24");
        buttonInspect.setBackground(new java.awt.Color(204, 204, 204));
        buttonInspect.setForeground(java.awt.Color.black);
        buttonInspect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonInspectActionPerformed(evt);
            }
        });
        
        panelDatabaseItems.add(buttonInspect, java.awt.BorderLayout.SOUTH);
        
        add(panelDatabaseItems, java.awt.BorderLayout.WEST);
        
        panel4.setLayout(new java.awt.GridLayout(1, 2, 5, 5));
        
        panel4.setFont(new java.awt.Font("Dialog", 0, 11));
        panel4.setName("panel12");
        panel4.setBackground(new java.awt.Color(204, 204, 204));
        panel4.setForeground(java.awt.Color.black);
        panel5.setLayout(new java.awt.BorderLayout());
        
        panel5.setFont(new java.awt.Font("Dialog", 0, 11));
        panel5.setName("panel13");
        panel5.setBackground(new java.awt.Color(204, 204, 204));
        panel5.setForeground(java.awt.Color.black);
        label3.setFont(new java.awt.Font("Dialog", 0, 11));
        label3.setName("label6");
        label3.setBackground(new java.awt.Color(204, 204, 204));
        label3.setForeground(java.awt.Color.black);
        label3.setText("Start date");
        label3.setAlignment(java.awt.Label.CENTER);
        panel5.add(label3, java.awt.BorderLayout.NORTH);
        
        panelStartDate.setLayout(new java.awt.GridLayout(5, 2));
        
        panelStartDate.setFont(new java.awt.Font("Dialog", 0, 11));
        panelStartDate.setName("panel15");
        panelStartDate.setBackground(new java.awt.Color(204, 204, 204));
        panelStartDate.setForeground(java.awt.Color.black);
        label4.setFont(new java.awt.Font("Dialog", 0, 11));
        label4.setName("label7");
        label4.setBackground(new java.awt.Color(204, 204, 204));
        label4.setForeground(java.awt.Color.black);
        label4.setText("Year");
        panelStartDate.add(label4);
        
        textFieldStartYear.setText("2001");
        textFieldStartYear.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartYear.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldStartYear.setForeground(java.awt.Color.black);
        panelStartDate.add(textFieldStartYear);
        
        label6.setFont(new java.awt.Font("Dialog", 0, 11));
        label6.setName("label9");
        label6.setBackground(new java.awt.Color(204, 204, 204));
        label6.setForeground(java.awt.Color.black);
        label6.setText("Month");
        panelStartDate.add(label6);
        
        textFieldStartMonth.setText("01");
        textFieldStartMonth.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartMonth.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldStartMonth.setForeground(java.awt.Color.black);
        panelStartDate.add(textFieldStartMonth);
        
        label7.setFont(new java.awt.Font("Dialog", 0, 11));
        label7.setName("label10");
        label7.setBackground(new java.awt.Color(204, 204, 204));
        label7.setForeground(java.awt.Color.black);
        label7.setText("Date");
        panelStartDate.add(label7);
        
        textFieldStartDate.setText("01");
        textFieldStartDate.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartDate.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldStartDate.setForeground(java.awt.Color.black);
        panelStartDate.add(textFieldStartDate);
        
        label8.setFont(new java.awt.Font("Dialog", 0, 11));
        label8.setName("label11");
        label8.setBackground(new java.awt.Color(204, 204, 204));
        label8.setForeground(java.awt.Color.black);
        label8.setText("Hour");
        panelStartDate.add(label8);
        
        textFieldStartHour.setText("00");
        textFieldStartHour.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartHour.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldStartHour.setForeground(java.awt.Color.black);
        panelStartDate.add(textFieldStartHour);
        
        label9.setFont(new java.awt.Font("Dialog", 0, 11));
        label9.setName("label12");
        label9.setBackground(new java.awt.Color(204, 204, 204));
        label9.setForeground(java.awt.Color.black);
        label9.setText("Minute");
        panelStartDate.add(label9);
        
        textFieldStartMinute.setText("00");
        textFieldStartMinute.setBackground(new java.awt.Color(255, 247, 233));
        textFieldStartMinute.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldStartMinute.setForeground(java.awt.Color.black);
        panelStartDate.add(textFieldStartMinute);
        
        panel5.add(panelStartDate, java.awt.BorderLayout.CENTER);
        
        panel4.add(panel5);
        
        panel6.setLayout(new java.awt.BorderLayout());
        
        panel6.setFont(new java.awt.Font("Dialog", 0, 11));
        panel6.setBackground(new java.awt.Color(204, 204, 204));
        panel6.setForeground(java.awt.Color.black);
        label1.setFont(new java.awt.Font("Dialog", 0, 11));
        label1.setName("label20");
        label1.setBackground(new java.awt.Color(204, 204, 204));
        label1.setForeground(java.awt.Color.black);
        label1.setText("End date");
        label1.setAlignment(java.awt.Label.CENTER);
        panel6.add(label1, java.awt.BorderLayout.NORTH);
        
        panelEndDate.setLayout(new java.awt.GridLayout(5, 2));
        
        panelEndDate.setFont(new java.awt.Font("Dialog", 0, 11));
        panelEndDate.setName("panel24");
        panelEndDate.setBackground(new java.awt.Color(204, 204, 204));
        panelEndDate.setForeground(java.awt.Color.black);
        label2.setFont(new java.awt.Font("Dialog", 0, 11));
        label2.setName("label21");
        label2.setBackground(new java.awt.Color(204, 204, 204));
        label2.setForeground(java.awt.Color.black);
        label2.setText("Year");
        panelEndDate.add(label2);
        
        textFieldEndYear.setText("2001");
        textFieldEndYear.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndYear.setName("textfield11");
        textFieldEndYear.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldEndYear.setColumns(10);
        textFieldEndYear.setForeground(java.awt.Color.black);
        panelEndDate.add(textFieldEndYear);
        
        label5.setFont(new java.awt.Font("Dialog", 0, 11));
        label5.setName("label22");
        label5.setBackground(new java.awt.Color(204, 204, 204));
        label5.setForeground(java.awt.Color.black);
        label5.setText("Month");
        panelEndDate.add(label5);
        
        textFieldEndMonth.setText("01");
        textFieldEndMonth.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndMonth.setName("textfield12");
        textFieldEndMonth.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldEndMonth.setForeground(java.awt.Color.black);
        panelEndDate.add(textFieldEndMonth);
        
        label10.setFont(new java.awt.Font("Dialog", 0, 11));
        label10.setName("label23");
        label10.setBackground(new java.awt.Color(204, 204, 204));
        label10.setForeground(java.awt.Color.black);
        label10.setText("Date");
        panelEndDate.add(label10);
        
        textFieldEndDate.setText("01");
        textFieldEndDate.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndDate.setName("textfield13");
        textFieldEndDate.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldEndDate.setForeground(java.awt.Color.black);
        panelEndDate.add(textFieldEndDate);
        
        label11.setFont(new java.awt.Font("Dialog", 0, 11));
        label11.setName("label24");
        label11.setBackground(new java.awt.Color(204, 204, 204));
        label11.setForeground(java.awt.Color.black);
        label11.setText("Hour");
        panelEndDate.add(label11);
        
        textFieldEndHour.setText("23");
        textFieldEndHour.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndHour.setName("textfield14");
        textFieldEndHour.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldEndHour.setForeground(java.awt.Color.black);
        panelEndDate.add(textFieldEndHour);
        
        label12.setFont(new java.awt.Font("Dialog", 0, 11));
        label12.setName("label25");
        label12.setBackground(new java.awt.Color(204, 204, 204));
        label12.setForeground(java.awt.Color.black);
        label12.setText("Minute");
        panelEndDate.add(label12);
        
        textFieldEndMinute.setText("59");
        textFieldEndMinute.setBackground(new java.awt.Color(255, 247, 233));
        textFieldEndMinute.setName("textfield15");
        textFieldEndMinute.setFont(new java.awt.Font("Dialog", 0, 11));
        textFieldEndMinute.setForeground(java.awt.Color.black);
        panelEndDate.add(textFieldEndMinute);
        
        panel6.add(panelEndDate, java.awt.BorderLayout.CENTER);
        
        panel4.add(panel6);
        
        add(panel4, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonInspectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
// Add your handling code here:
      //Get the selected item.
      String item = this.listDatabaseItems.getSelectedItem();
      //Show the meta data.
      new ShowMetaDataFrame(item).setVisible(true);
  }//GEN-LAST:event_buttonInspectActionPerformed

  private void listDatabaseItemsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemsItemStateChanged
// Add your handling code here:
      //Get the selected item.
      String item = this.listDatabaseItems.getSelectedItem();
      //Get the end date for this item.
//      Database db = Database.getInstance(item);
//      Date endDate = db.meta.getEndDate();
      Date endDate = odiDatabase.getEndDate(item);
      //Create a calendar object.
      this.cal.setTime(endDate);
      //Put the end date into the end date text fields.
      DecimalFormat df = new DecimalFormat("##00");
      this.textFieldEndYear.setText(df.format(cal.get(Calendar.YEAR)));
      this.textFieldEndMonth.setText(df.format(cal.get(Calendar.MONTH)+1));
      this.textFieldEndDate.setText(df.format(cal.get(Calendar.DATE)));
      this.textFieldEndHour.setText(df.format(cal.get(Calendar.HOUR_OF_DAY)));
      this.textFieldEndMinute.setText(df.format(cal.get(Calendar.MINUTE)));
      //Set the start date to the beginning of the same day.
      this.cal.clear(Calendar.HOUR_OF_DAY);
      this.cal.clear(Calendar.MINUTE);
      //Put the date into the start date text fields.
      this.textFieldStartYear.setText(df.format(cal.get(Calendar.YEAR)));
      this.textFieldStartMonth.setText(df.format(cal.get(Calendar.MONTH)+1));
      this.textFieldStartDate.setText(df.format(cal.get(Calendar.DATE)));
      this.textFieldStartHour.setText(df.format(cal.get(Calendar.HOUR_OF_DAY)));
      this.textFieldStartMinute.setText(df.format(cal.get(Calendar.MINUTE)));
  }//GEN-LAST:event_listDatabaseItemsItemStateChanged

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonExportActionPerformed
      try {
	  this.verifyInputFields();

	  //Select file.
	  FileDialog fd = new FileDialog(this,"Select a file",FileDialog.SAVE);
	  fd.show();
	  if (fd.getFile() != null) {
		String fileName = fd.getDirectory() + fd.getFile();
		//Create an ExportAscii object from the selected database item.
		ExportAscii ea = new ExportAscii(this.listDatabaseItems.getSelectedItem());
		//Get the start and end dates.
		Date sd = this.parseStartDate();
		Date ed = this.parseEndDate();

		ea.export(sd,ed,fileName);
          }
      }
      catch (IOException e) {
          new InfoDialog(this,"Error!",e.getMessage(),40).setVisible(true);
          System.err.println(e);
      }       
      catch (TextFieldException e) {
	  System.out.println(e.getMessage());
	  if(ed!=null)
	      ed.setVisible(true);
	  else
	      ed = new ErrorDialog(this,"\n"+e.getMessage());
      }
  }//GEN-LAST:event_buttonExportActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new ExportAsciiFrame ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelExport;
    private java.awt.Button buttonExport;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    private java.awt.Panel panelDatabaseItems;
    private java.awt.Label labelDatabaseItems;
    private java.awt.List listDatabaseItems;
    private java.awt.Button buttonInspect;
    private java.awt.Panel panel4;
    private java.awt.Panel panel5;
    private java.awt.Label label3;
    private java.awt.Panel panelStartDate;
    private java.awt.Label label4;
    private java.awt.TextField textFieldStartYear;
    private java.awt.Label label6;
    private java.awt.TextField textFieldStartMonth;
    private java.awt.Label label7;
    private java.awt.TextField textFieldStartDate;
    private java.awt.Label label8;
    private java.awt.TextField textFieldStartHour;
    private java.awt.Label label9;
    private java.awt.TextField textFieldStartMinute;
    private java.awt.Panel panel6;
    private java.awt.Label label1;
    private java.awt.Panel panelEndDate;
    private java.awt.Label label2;
    private java.awt.TextField textFieldEndYear;
    private java.awt.Label label5;
    private java.awt.TextField textFieldEndMonth;
    private java.awt.Label label10;
    private java.awt.TextField textFieldEndDate;
    private java.awt.Label label11;
    private java.awt.TextField textFieldEndHour;
    private java.awt.Label label12;
    private java.awt.TextField textFieldEndMinute;
    // End of variables declaration//GEN-END:variables

}
