package saaps.saam;

import ptolemy.plot.*;

import java.rmi.Naming; 
import java.rmi.RemoteException; 

import java.util.Date;
import java.util.Calendar;
import java.util.Locale;
import java.util.TimeZone;

import saaps.math.RowVector;

import java.awt.*;
import java.applet.Applet;

public class PlotRMIApplet extends PlotApplet {

    RowVector myrowvec;

    //overlapping dates
    Date dates[] = new Date[2];
    //dates for SP resp. Anom
    Date SPdates[] = new Date[2];
    Date Anomdates[] = new Date[2];

    String[] list;
    String[] str;
    String[] Astr;

    // "obj" is the identifier that we'll use to refer 
    // to the remote object that implements the "Hello" 
    // interface 
    SupEpochRMI obj = null; 

    ///////////////////////////////////////////////////////////////////
    ////                         public methods                    ////

    /**
     * Return a string describing this applet.
     */
    public String getAppletInfo() {
        return "PlotDemo 2.0: Demo of Plot.\n" +
            "By: Edward A. Lee, eal@eecs.berkeley.edu\n " +
            "($Id: PlotRMIApplet.java,v 1.1.1.1 2000/09/28 08:43:52 saaps Exp $)";
    }

    /**
     * Initialize the applet.  Here we step through an example of what the
     * the applet can do.
     */
    public void init() {
        super.init();

	//Try to get the RMI object and data ...
	try { 
	    obj = (SupEpochRMI)Naming.lookup("//" + 
		   getCodeBase().getHost() + "/SupEpochRMIServer"); 


	} catch (Exception e) { 
	    System.out.println("SupEpochRMIApplet exception: " + 
				    e.getMessage()); 
	    e.printStackTrace(); 
	}

	try { 

	    // Get start/stop date/times for "overlapping data
	    dates=obj.getDate("Kp", "M3");

	    //Get start/stop date/time for "single" data
	    SPdates=obj.getSPDates("Kp");
	    Anomdates=obj.getAnomDates("M3");

	    //What data is available ?
	    str = obj.getDatabaseSPList();
	    Astr = obj.getDatabaseAnomList();
	    
	    //What time interval do we want data for ?
	    Date dateStart=new Date(95,1-1,1,0,0,0);
	    Date dateEnd=new Date(95,3-1,1,0,0,0);

	    long startTime=dateStart.getTime();
	    long endTime=dateEnd.getTime();
	    long startWindow=-1*10 * 24 * 3600 * 1000;
	    long endWindow=10 * 24 * 3600 * 1000;

	    myrowvec=obj.getSupData("Kp","M3",startTime,endTime, startWindow, endWindow);


	    // Plot.
	    // Create the plot surface.
	    //	    Plot plot = new Plot();
	    //plot.setSize(430,300);
	    //plot.setButtons(true);

	} catch (Exception e) { 
	    System.out.println("SupEpochRMIApplet exception: " + 
				    e.getMessage()); 
	    e.printStackTrace(); 
	}


        Plot plot = (Plot)plot();
	//plot.setSize(430,300);
	plot.setButtons(true);

        plot.setTitle("SupEpoch RMI Line Plot Demo");
//         plot.setYRange(-4, 4);
//         plot.setXRange(0, 100);
	plot.setXLabel("time");
	plot.setYLabel("My Data");
//         plot.addYTick("-PI", -Math.PI);
//         plot.addYTick("-PI/2", -Math.PI/2);
//         plot.addYTick("0", 0);
//         plot.addYTick("PI/2", Math.PI/2);
//         plot.addYTick("PI", Math.PI);
//         plot.setMarksStyle("none");
	//	plot.setImpulses(true);

	// Go through the objects in the vector.
	boolean first = true;
	
	for (int i=0;i<myrowvec.getNumOfCols();i++) {
	    plot.addPoint(0,(double)i,myrowvec.getElement(i),!first);
	    first = false;
	}

    }
}
