/*
 * ShowMetaDataFrame.java
 *
 * Created on June 5, 2001, 1:05 PM
 */

package saaps.dbt;

//import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.text.NumberFormat;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Map;
import java.util.HashMap;
import saaps.util.AppHelp;

/**
 *
 * @author  root
 * @version 
 */
public class ShowMetaDataFrame extends java.awt.Frame {
    private Map sedat2odi = new HashMap();

    //Help
    private AppHelp help=null;
    
    /** Creates new form ShowMetaDataFrame */
    public ShowMetaDataFrame() {
        this.initComponents();
        this.initListDatabaseItems();
        this.pack();
    }
    
    public ShowMetaDataFrame(String dbItem) {
        this();
        //Mark the item as selected.
        String[] items = this.listDatabaseItems.getItems();
        int i=-1;
        while (!items[++i].equalsIgnoreCase(dbItem));
        this.listDatabaseItems.select(i);
        this.listDatabaseItems.makeVisible(i);
        //Show the meta data.
        this.showMetaData(dbItem);
    }
    
    private void initListDatabaseItems() {
	//Get the database items.
	Vector items = DatabaseItems.list();
	//Create the list.
	for (int i=0;i<items.size();i++) {
	    sedat2odi.put((String) (((Vector)items.elementAt(i)).elementAt(1)),(String) (((Vector)items.elementAt(i)).elementAt(0)));
//System.out.println(map2sedat.get((String) (((Vector)items.elementAt(i)).elementAt(0))));
	    this.listDatabaseItems.add((String) (((Vector)items.elementAt(i)).elementAt(1)));
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        panelDatabase = new java.awt.Panel();
        labelDatabaseItems = new java.awt.Label();
        listDatabaseItems = new java.awt.List();
        textArea = new java.awt.TextArea();
        panelQuit = new java.awt.Panel();
        buttonHelp = new java.awt.Button();
        buttonQuit = new java.awt.Button();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        panelDatabase.setLayout(new java.awt.BorderLayout());
        
        panelDatabase.setFont(new java.awt.Font("Dialog", 0, 11));
        panelDatabase.setName("panel2");
        panelDatabase.setBackground(new java.awt.Color(204, 204, 204));
        panelDatabase.setForeground(java.awt.Color.black);
        labelDatabaseItems.setFont(new java.awt.Font("Dialog", 0, 11));
        labelDatabaseItems.setBackground(new java.awt.Color(204, 204, 204));
        labelDatabaseItems.setForeground(java.awt.Color.black);
        labelDatabaseItems.setText("Database items");
        panelDatabase.add(labelDatabaseItems, java.awt.BorderLayout.NORTH);
        
        listDatabaseItems.setFont(new java.awt.Font("Dialog", 0, 11));
        listDatabaseItems.setBackground(new java.awt.Color(255, 247, 233));
        listDatabaseItems.setForeground(java.awt.Color.black);
        listDatabaseItems.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                listDatabaseItemsItemStateChanged(evt);
            }
        });
        
        panelDatabase.add(listDatabaseItems, java.awt.BorderLayout.CENTER);
        
        add(panelDatabase, java.awt.BorderLayout.WEST);
        
        textArea.setBackground(new java.awt.Color(223, 223, 223));
        textArea.setEditable(false);
        textArea.setFont(new java.awt.Font("Courier", 0, 11));
        textArea.setForeground(java.awt.Color.black);
        add(textArea, java.awt.BorderLayout.CENTER);
        
        panelQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        panelQuit.setName("panel3");
        panelQuit.setBackground(new java.awt.Color(204, 204, 204));
        panelQuit.setForeground(java.awt.Color.black);
        buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonHelp.setLabel("Help");
        buttonHelp.setName("button21");
        buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
        buttonHelp.setForeground(java.awt.Color.black);
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });
        
        panelQuit.add(buttonHelp);
        
        buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
        buttonQuit.setLabel("Quit");
        buttonQuit.setName("button12");
        buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
        buttonQuit.setForeground(java.awt.Color.black);
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });
        
        panelQuit.add(buttonQuit);
        
        add(panelQuit, java.awt.BorderLayout.SOUTH);
        
    }//GEN-END:initComponents

    private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
    }//GEN-LAST:event_buttonHelpActionPerformed

  private void listDatabaseItemsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemsItemStateChanged
      // Add your handling code here:
      //Get the selected item.
      String item = this.listDatabaseItems.getSelectedItem();
//      int index = this.listDatabaseItems.getSelectedIndex();
//System.out.println("index: " + index);
      //Show the meta data.
      showMetaData(item);
  }//GEN-LAST:event_listDatabaseItemsItemStateChanged
  
  private void showMetaData(String item) {
//    textArea.setText(ShowMetaData.getMetaString(item,(String)map2sedat.get(item)));
    textArea.setText(ShowMetaData.getMetaString((String)sedat2odi.get(item),item));
  }
  
  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();
      this.dispose();
  }//GEN-LAST:event_buttonQuitActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new ShowMetaDataFrame ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Panel panelDatabase;
    private java.awt.Label labelDatabaseItems;
    private java.awt.List listDatabaseItems;
    private java.awt.TextArea textArea;
    private java.awt.Panel panelQuit;
    private java.awt.Button buttonHelp;
    private java.awt.Button buttonQuit;
    // End of variables declaration//GEN-END:variables

}
