package saaps.math;

public class Matrix extends Jama.Matrix
{
  public Matrix(int m, int n)
  {
    super(m,n);
  }

  public Matrix(int m, int n, double s)
  {
    super(m,n,s);
  }

  public Matrix(double[][] A)
  {
    super(A);
  }

  public Matrix(double[][] A, int m, int n)
  {
    super(A,m,n);
  }

  public Matrix(double[] a, int m)
  {
    super(a,m);
  }

  public Matrix pow(double p)
  {
    Matrix res = new Matrix(getRowDimension(),getColumnDimension());
    for (int r=0;r<getRowDimension();r++)
      for (int c=0;c<getColumnDimension();c++)
        res.set(r,c,java.lang.Math.pow(get(r,c),p));
    return res;
  }

  public Matrix sum()
  {
    Matrix res = new Matrix(1,getColumnDimension());
    for (int r=0;r<getRowDimension();r++)
      res.plus(getMatrix(r,r,0,getColumnDimension()-1));
    return res;
  }
}
