package saaps.math;

import java.io.*;

public class RowVector implements Serializable {
	int numOfCols;
	double[] element;

	public RowVector(int i)
	{
		numOfCols = i;
		element = new double[numOfCols];
	}

	public RowVector(RowVector rv)
	{
		numOfCols = rv.getNumOfCols();
		element = new double[numOfCols];
		for (int i=0;i<numOfCols;i++)
			element[i] = rv.getElement(i);
	}
	
	public void add(RowVector rv)
	{
		if(numOfCols == rv.getNumOfCols())
			for (int i=0;i<numOfCols;i++)
				element[i] += rv.getElement(i);
		else
		{
			System.err.println("Number of columns must be equal!");
			System.exit(1);
		}
	}

	public double times(ColVector cv)
	{
		double res = 0;
		if(numOfCols == cv.getNumOfRows())
			for (int i=0;i<numOfCols;i++)
				res += element[i] * cv.getElement(i);
		else
		{
			System.err.println("Number of rows and columns must be equal!");
			System.exit(1);
		}
		return res;
	}
	
	public RowVector times(RowVector rv)
	{
		RowVector res = null;
		if(numOfCols == rv.getNumOfCols())
		{
			res = new RowVector(numOfCols);
			for (int i=0;i<numOfCols;i++)
				res.setElement(i, element[i] * rv.getElement(i));
		}
		else
		{
			System.err.println("Number of rows and columns must be equal!");
			System.exit(1);
		}
		return res;
	}		
	
	public RowVector times(double v)
	{
		RowVector res = new RowVector(numOfCols);
		for (int i=0;i<numOfCols;i++)
			res.setElement(i, element[i] * v);
		return res;
	}		
	
	public ColVector transpose()
	{
		ColVector res = new ColVector(numOfCols);
		for (int i=0;i<numOfCols;i++)
			res.setElement(i,element[i]);
		return res;
	}
	
	public double getElement(int c)
	{
		return element[c];
	}
	
	public void setElement(int c, double v)
	{
		element[c] = v;
	}
	
	public int getNumOfCols()
	{
		return numOfCols;
	}
}
