package saaps.saam;

//import java.awt.Frame;
import java.applet.AppletContext;
import java.io.IOException;
import java.net.*;
import java.rmi.*;
import java.util.*;

import saaps.dbt.DatabaseRMI;
import saaps.dbt.MetaData;
import saaps.util.IllegalTimeSeriesException;
import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.TimeSeriesIndexException;

/**
 *
 * @author
 * @version
 */
public class SEAApplet extends java.applet.Applet {

  private DatabaseRMI dbRMI;
  private MetaData metaData;
  private TimeZone tz = TimeZone.getTimeZone("GMT");
  private Calendar cal = Calendar.getInstance(tz);

  /** Initializes the Form */
  public void init () {
    initComponents ();
    choiceStart.add("days");
    choiceStart.add("hours");
    choiceStart.add("minutes");
    choiceEnd.add("days");
    choiceEnd.add("hours");
    choiceEnd.add("minutes");
    int width = 650;
    int height = 550;
    resize(width,height);
    cal.clear();
    initDatabaseRMI();
    initListDatabase();
  }

  private void initDatabaseRMI()
  {
    try
    {
      dbRMI = (DatabaseRMI)
      Naming.lookup("//" + getCodeBase().getHost() +
      ":2001" + "/DatabaseRMIServer");
    }
    catch(NotBoundException nbe)
    {
      System.err.println(nbe);
    }
    catch(MalformedURLException murle)
    {
      System.err.println(murle);
    }
    catch(RemoteException re)
    {
      System.err.println(re);
    }
  }

  private void initListDatabase()
  {
    //    DatabaseRMI dbRMI = createDatabaseRMI();
    Vector list = null;
    try
    {
      list = dbRMI.getDatabaseList();
    }
    catch (RemoteException e)
    {
      System.err.println(e);
    }
    for (int i=0;i<list.size();i++)
    listDatabase.add((String) list.elementAt(i));
    listDatabase.select(0);
    
    String dbo = listDatabase.getSelectedItem();
    // Create the database connection.
    //    DatabaseRMI dbRMI = createDatabaseRMI();
    // Get the meta data.
    MetaData md = null;
    try {
        md = dbRMI.getMetaData(dbo);
    }
    catch (RemoteException e) {
        System.err.println(e);
    }
    // Get the field names.
    String[] fn = md.getFieldNames();
    // Clear the field list
    listField.removeAll();
    // Add the items
    for (int i=0;i<fn.length;i++)
        listField.add(fn[i]);
    listField.select(0);
  }
  
  /** This method is called from within the init() method to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      labelTitle = new java.awt.Label();
      labelEventList = new java.awt.Label();
      textAreaEventList = new java.awt.TextArea();
      textFieldEventList = new java.awt.TextField();
      labelEventWindow = new java.awt.Label();
      labelStart = new java.awt.Label();
      textFieldStart = new java.awt.TextField();
      choiceStart = new java.awt.Choice();
      labelEnd = new java.awt.Label();
      textFieldEnd = new java.awt.TextField();
      choiceEnd = new java.awt.Choice();
      labelDatabase = new java.awt.Label();
      labelField = new java.awt.Label();
      buttonCalculate = new java.awt.Button();
      listDatabase = new java.awt.List();
      listField = new java.awt.List();
      buttonHelp = new java.awt.Button();
      labelRandomList = new java.awt.Label();
      textFieldRandomList = new java.awt.TextField();
      textAreaRandomList = new java.awt.TextArea();
      labelNumOfRandom = new java.awt.Label();
      textFieldNumOfRandom = new java.awt.TextField();
      buttonGenerateRandomList = new java.awt.Button();
      buttonRandomPlot = new java.awt.Button();
      buttonInspect = new java.awt.Button();
      
      setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
      
      labelTitle.setFont(new java.awt.Font("Dialog", 1, 14));
      labelTitle.setText("Superposed Epoch Analysis");
      add(labelTitle, new org.netbeans.lib.awtextra.AbsoluteConstraints(30, 20, -1, -1));
      
      labelEventList.setText("Event List");
      add(labelEventList, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, -1, -1));
      
      textAreaEventList.setText("2000 07 14 10 45\n2000 11 08 23 35");
      textAreaEventList.setBackground(new java.awt.Color(255, 247, 233));
      textAreaEventList.setFont(new java.awt.Font("Monospaced", 0, 12));
      textAreaEventList.setForeground(java.awt.Color.black);
      add(textAreaEventList, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 140, 170, 180));
      
      textFieldEventList.setText("YYYY MM DD hh mm ss");
      textFieldEventList.setBackground(new java.awt.Color(255, 247, 233));
      textFieldEventList.setEditable(false);
      textFieldEventList.setFont(new java.awt.Font("Monospaced", 0, 12));
      textFieldEventList.setForeground(java.awt.Color.black);
      add(textFieldEventList, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, -1));
      
      labelEventWindow.setText("Event Window");
      add(labelEventWindow, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 100, -1, -1));
      
      labelStart.setText("Start");
      add(labelStart, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 140, -1, -1));
      
      textFieldStart.setText("-2");
      textFieldStart.setBackground(new java.awt.Color(255, 247, 233));
      textFieldStart.setForeground(java.awt.Color.black);
      textFieldStart.setName("textfieldStart");
      add(textFieldStart, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 170, 50, -1));
      
      add(choiceStart, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 170, -1, -1));
      
      labelEnd.setText("End");
      add(labelEnd, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 230, -1, -1));
      
      textFieldEnd.setText("2");
      textFieldEnd.setBackground(new java.awt.Color(255, 247, 233));
      textFieldEnd.setForeground(java.awt.Color.black);
      add(textFieldEnd, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 260, 50, -1));
      
      add(choiceEnd, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 260, -1, -1));
      
      labelDatabase.setText("Database");
      add(labelDatabase, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 350, -1, -1));
      
      labelField.setText("Field");
      add(labelField, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 350, -1, -1));
      
      buttonCalculate.setLabel("Plot Events");
      buttonCalculate.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonCalculateActionPerformed(evt);
          }
      });
      
      add(buttonCalculate, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 500, -1, -1));
      
      listDatabase.setBackground(new java.awt.Color(255, 247, 233));
      listDatabase.setForeground(java.awt.Color.black);
      listDatabase.addItemListener(new java.awt.event.ItemListener() {
          public void itemStateChanged(java.awt.event.ItemEvent evt) {
              listDatabaseItemStateChanged(evt);
          }
      });
      
      add(listDatabase, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 380, 150, 100));
      
      listField.setBackground(new java.awt.Color(255, 247, 233));
      listField.setForeground(java.awt.Color.black);
      add(listField, new org.netbeans.lib.awtextra.AbsoluteConstraints(220, 380, 150, 100));
      
      buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
      buttonHelp.setFont(new java.awt.Font("Dialog", 1, 14));
      buttonHelp.setForeground(java.awt.Color.black);
      buttonHelp.setLabel("Help");
      buttonHelp.setName("buttonHelp");
      buttonHelp.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonHelpActionPerformed(evt);
          }
      });
      
      add(buttonHelp, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 20, -1, -1));
      
      labelRandomList.setText("Random List");
      add(labelRandomList, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 70, -1, -1));
      
      textFieldRandomList.setText("YYYY MM DD hh mm ss");
      textFieldRandomList.setBackground(new java.awt.Color(255, 247, 233));
      textFieldRandomList.setEditable(false);
      textFieldRandomList.setFont(new java.awt.Font("Monospaced", 0, 12));
      textFieldRandomList.setForeground(java.awt.Color.black);
      add(textFieldRandomList, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 100, -1, -1));
      
      textAreaRandomList.setBackground(new java.awt.Color(255, 247, 233));
      textAreaRandomList.setFont(new java.awt.Font("Monospaced", 0, 12));
      textAreaRandomList.setForeground(java.awt.Color.black);
      add(textAreaRandomList, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 140, 170, 180));
      
      labelNumOfRandom.setBackground(new java.awt.Color(204, 204, 204));
      labelNumOfRandom.setFont(new java.awt.Font("Dialog", 0, 11));
      labelNumOfRandom.setForeground(java.awt.Color.black);
      labelNumOfRandom.setText("Number of random events");
      add(labelNumOfRandom, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 330, -1, -1));
      
      textFieldNumOfRandom.setText("5");
      textFieldNumOfRandom.setBackground(new java.awt.Color(255, 247, 233));
      textFieldNumOfRandom.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldNumOfRandom.setForeground(java.awt.Color.black);
      add(textFieldNumOfRandom, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 360, 50, -1));
      
      buttonGenerateRandomList.setBackground(new java.awt.Color(204, 204, 204));
      buttonGenerateRandomList.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonGenerateRandomList.setForeground(java.awt.Color.black);
      buttonGenerateRandomList.setLabel("Generate random list");
      buttonGenerateRandomList.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonGenerateRandomListActionPerformed(evt);
          }
      });
      
      add(buttonGenerateRandomList, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 420, -1, -1));
      
      buttonRandomPlot.setBackground(new java.awt.Color(204, 204, 204));
      buttonRandomPlot.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonRandomPlot.setForeground(java.awt.Color.black);
      buttonRandomPlot.setLabel("Plot Random Events");
      buttonRandomPlot.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonRandomPlotActionPerformed(evt);
          }
      });
      
      add(buttonRandomPlot, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 450, -1, -1));
      
      buttonInspect.setBackground(new java.awt.Color(204, 204, 204));
      buttonInspect.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonInspect.setForeground(java.awt.Color.black);
      buttonInspect.setLabel("Inspect");
      buttonInspect.setName("button9");
      buttonInspect.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonInspectActionPerformed(evt);
          }
      });
      
      add(buttonInspect, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 500, -1, -1));
      
  }//GEN-END:initComponents

  private void buttonInspectActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonInspectActionPerformed
// Add your handling code here:
    DatabaseRMI dbrmi = null;
    String dbObject = (String) listDatabase.getSelectedItem();
    try
    {
      dbrmi = (DatabaseRMI)
        Naming.lookup("//" + getCodeBase().getHost() +
        ":2001" + "/DatabaseRMIServer");
      metaData = dbrmi.getMetaData(dbObject);
    }
    catch(NotBoundException nbe)
    {
      System.err.println(nbe);
    }
    catch(MalformedURLException murle)
    {
      System.err.println(murle);
    }
    catch(RemoteException re)
    {
      System.err.println(re);
    }
    (new MetaDataDialog(getAppletFrame(),metaData)).show();
  }//GEN-LAST:event_buttonInspectActionPerformed

  private void buttonRandomPlotActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRandomPlotActionPerformed
      try {
          // Read the random event list.
          Date[] events = parseList(textAreaRandomList);
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          // Read the database list.
          String dbo = parseDatabaseList();
          // Read the field list.
          int field = parseFieldList();
          //Create dialog window.
          //Get the data.
          SEAData sea = null;
          sea = new SEAData(this.getAppletFrame(),events,startWindow,endWindow,dbRMI,dbo,field);
          sea.start();
      }
      catch (NumberFormatException e) {
          new ErrorDialog(getAppletFrame(),"Incorrect date format in list.");
      }      
  }//GEN-LAST:event_buttonRandomPlotActionPerformed

  private void buttonGenerateRandomListActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGenerateRandomListActionPerformed
      try {
          //Get the number of random events to produce.
          int numOfRandom = 1;
          numOfRandom = Integer.parseInt(textFieldNumOfRandom.getText());
          // Read the event list.
          Date[] events = parseEventList();
          //Find the first and last events.
          long firstEvent = events[0].getTime();
          long lastEvent = firstEvent;
          for (int i=0;i<events.length;i++) {
              if (events[i].getTime() < firstEvent)
                  firstEvent = events[i].getTime();
              if (events[i].getTime() > lastEvent)
                  lastEvent = events[i].getTime();
          }
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          firstEvent -= startWindow;
          lastEvent += endWindow;
          //Generate the random times.
          //    Date[] randomList = new Date[numOfRandom];
          Random rand = new Random();
          textAreaRandomList.setText("");
          for (int i=0;i<numOfRandom;i++) {
              StringBuffer strBuf = new StringBuffer();
              long randTime = (long) (rand.nextDouble() * (lastEvent-firstEvent) + firstEvent);
              Date randomDate = new Date(randTime);
              Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
              cal.setTime(randomDate);
              cal.clear(Calendar.MILLISECOND);
              strBuf.append(cal.get(Calendar.YEAR));
              int tmp = cal.get(Calendar.MONTH) + 1;
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.DATE);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.HOUR_OF_DAY);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.MINUTE);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              tmp = cal.get(Calendar.SECOND);
              if (tmp<10)
                  strBuf.append(" 0" + tmp);
              else
                  strBuf.append(" " + tmp);
              strBuf.append("\n");
              textAreaRandomList.append(strBuf.toString());
          }
      }
      catch (NumberFormatException e) {
          new ErrorDialog(getAppletFrame(),"Incorrect date format in list.");
      }
  }//GEN-LAST:event_buttonGenerateRandomListActionPerformed

  private void buttonHelpActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
    AppletContext ac = getAppletContext();
    URL url = getDocumentBase();
    try
    {
      URL urlDoc = new URL(url,"SEAAppletHelp.html");
      ac.showDocument(urlDoc,"SEA Applet Help");
    }
    catch (MalformedURLException murle)
    {
      System.err.println(murle);
    }
  }//GEN-LAST:event_buttonHelpActionPerformed

  private void listDatabaseItemStateChanged (java.awt.event.ItemEvent evt) {//GEN-FIRST:event_listDatabaseItemStateChanged
    // Add your handling code here:
    // Get the database object.
    String dbo = listDatabase.getSelectedItem();
    // Create the database connection.
    //    DatabaseRMI dbRMI = createDatabaseRMI();
    // Get the meta data.
    MetaData md = null;
    try
    {
      md = dbRMI.getMetaData(dbo);
    }
    catch (RemoteException e)
    {
      System.err.println(e);
    }
    // Get the field names.
    String[] fn = md.getFieldNames();
    // Clear the field list
    listField.removeAll();
    // Add the items
    for (int i=0;i<fn.length;i++)
    listField.add(fn[i]);
    listField.select(0);
  }//GEN-LAST:event_listDatabaseItemStateChanged

  private void buttonCalculateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCalculateActionPerformed
      try {
          Date[] events = parseList(textAreaEventList);
          // Read the event window.
          long startWindow = parseEventWindowStart();
          long endWindow = parseEventWindowEnd();
          // Read the database list.
          String dbo = parseDatabaseList();
          // Read the field list.
          int field = parseFieldList();
          SEAData sea = null;
          sea = new SEAData(this.getAppletFrame(),events,startWindow,endWindow,dbRMI,dbo,field);
          sea.start();
      }
      catch (NumberFormatException e) {
          new ErrorDialog(getAppletFrame(),"Incorrect date format in list.");
      }
  }//GEN-LAST:event_buttonCalculateActionPerformed

  private java.awt.Frame getAppletFrame()
  {
    java.awt.Component curr = this;
    while (!(curr instanceof java.awt.Frame))
    curr = curr.getParent();
    return (java.awt.Frame) curr;
  }

  private Date[] parseList(java.awt.TextArea ta)
  {
    int[] dateFields = {Calendar.YEAR, Calendar.MONTH, Calendar.DATE,
    Calendar.HOUR_OF_DAY, Calendar.MINUTE, Calendar.SECOND};
    //    int numOfRows = textAreaEventList.getRows();
    String allText = ta.getText();
    // Tokenize with respect to newline.
    StringTokenizer stLine = new StringTokenizer(allText,"\n");
    int numOfLines = stLine.countTokens();
    Date[] res = new Date[numOfLines];
    //    int numOfFields = numOfTokens/numOfRows;
    int row = 0;
    for (int i=0;i<numOfLines;i++)
    {
      // Tokenize one line.
      StringTokenizer stOneLine = new StringTokenizer(stLine.nextToken());
      //      String token = st.nextToken();
      int field = 0;
      while (stOneLine.hasMoreTokens())
      {
        String token = stOneLine.nextToken();
        int t = Integer.parseInt(token);
        // The month number is the month minus 1.
        if (field==1)
        t--;
        cal.set(dateFields[field],t);
        field++;
      }
      res[row] = cal.getTime();
      row++;
    }
    return res;
  }
  private Date[] parseEventList()
  {
    int[] dateFields = {Calendar.YEAR, Calendar.MONTH, Calendar.DATE,
    Calendar.HOUR_OF_DAY, Calendar.MINUTE, Calendar.SECOND};
    //    int numOfRows = textAreaEventList.getRows();
    String allText = textAreaEventList.getText();
    // Tokenize with respect to newline.
    StringTokenizer stLine = new StringTokenizer(allText,"\n");
    int numOfLines = stLine.countTokens();
    Date[] res = new Date[numOfLines];
    //    int numOfFields = numOfTokens/numOfRows;
    int row = 0;
    for (int i=0;i<numOfLines;i++)
    {
      // Tokenize one line.
      StringTokenizer stOneLine = new StringTokenizer(stLine.nextToken());
      //      String token = st.nextToken();
      int field = 0;
      while (stOneLine.hasMoreTokens())
      {
        String token = stOneLine.nextToken();
        int t = Integer.parseInt(token);
        // The month number is the month minus 1.
        if (field==1)
        t--;
        cal.set(dateFields[field],t);
        field++;
      }
      res[row] = cal.getTime();
      row++;
    }
    return res;
  }

  private long parseEventWindowStart()
  {
    long res;
    String s = textFieldStart.getText();
    int i = choiceStart.getSelectedIndex();
    res = parseEventWindow(s,i);
    return res;
  }

  private long parseEventWindowEnd()
  {
    long res;
    String s = textFieldEnd.getText();
    int i = choiceEnd.getSelectedIndex();
    res = parseEventWindow(s,i);
    return res;
  }

  private long parseEventWindow(String s, int i)
  {
    long res = -1;
      res = Long.parseLong(s);
    switch (i)
    {
      case 0:
      res = res*24*60*60*1000;
      break;
      case 1:
      res = res*60*60*1000;
      break;
      case 2:
      res = res*60*1000;
    }
    return res;
  }

  private String parseDatabaseList()
  {
    String res;
    res = listDatabase.getSelectedItem();
    return res;
  }

  private int parseFieldList()
  {
    int res;
    res = listField.getSelectedIndex();
    return res;
  }

  /*  private DatabaseRMI createDatabaseRMI()
  {
  DatabaseRMI dbRMI = null;
  try
  {
  dbRMI = (DatabaseRMI)
  Naming.lookup("//" + getCodeBase().getHost() +
  ":2001" + "/DatabaseRMIServer");
  }
  catch(NotBoundException nbe)
  {
  System.err.println(nbe);
  }
  catch(MalformedURLException murle)
  {
  System.err.println(murle);
  }
  catch(RemoteException re)
  {
  System.err.println(re);
  }
  return dbRMI;
  }
   */

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label labelTitle;
  private java.awt.Label labelEventList;
  private java.awt.TextArea textAreaEventList;
  private java.awt.TextField textFieldEventList;
  private java.awt.Label labelEventWindow;
  private java.awt.Label labelStart;
  private java.awt.TextField textFieldStart;
  private java.awt.Choice choiceStart;
  private java.awt.Label labelEnd;
  private java.awt.TextField textFieldEnd;
  private java.awt.Choice choiceEnd;
  private java.awt.Label labelDatabase;
  private java.awt.Label labelField;
  private java.awt.Button buttonCalculate;
  private java.awt.List listDatabase;
  private java.awt.List listField;
  private java.awt.Button buttonHelp;
  private java.awt.Label labelRandomList;
  private java.awt.TextField textFieldRandomList;
  private java.awt.TextArea textAreaRandomList;
  private java.awt.Label labelNumOfRandom;
  private java.awt.TextField textFieldNumOfRandom;
  private java.awt.Button buttonGenerateRandomList;
  private java.awt.Button buttonRandomPlot;
  private java.awt.Button buttonInspect;
  // End of variables declaration//GEN-END:variables

}
