/*
 * SEAPlotFrame.java
 *
 * Created on August 16, 2000, 10:12 AM
 */
 
package saaps.saam;

import java.awt.Menu;
import java.awt.CheckboxMenuItem;
import java.util.Date;

import saaps.util.PlotFrame;
import saaps.util.TimeSeries;
import saaps.util.TimeSeriesPlot;

/** 
 *
 * @author  saaps
 * @version 
 */
public class SEAPlotFrame extends PlotFrame {

  private TimeSeries timeSeries;
  private TimeSeriesPlot timeSeriesPlot;
//  private TimeSeriesPlot timeSeriesPlot;
//  private int numberOfEvents;
  private Menu menuDisplay;
  private CheckboxMenuItem cbMenuItemAll;
  private CheckboxMenuItem cbMenuItemSum;
  private CheckboxMenuItem cbMenuItemAve;

  /** Creates new SEAPlotFrame */
  public SEAPlotFrame() {
    super();
  }
  
  public SEAPlotFrame(TimeSeries ts)
  {
    super(ts);
    timeSeries = ts;
    timeSeriesPlot = super.timeSeriesPlot;
    initComponents();
    timeSeriesPlot.useRelTime();
    timeSeriesPlot.plotData();
    timeSeriesPlot.repaint();
  }
  
  private void initComponents()
  {
    menuDisplay = new Menu("Display");
    cbMenuItemAll = new CheckboxMenuItem("All");
    cbMenuItemSum = new CheckboxMenuItem("Sum");
    cbMenuItemAve = new CheckboxMenuItem("Average");
    cbMenuItemAll.setState(true);
    cbMenuItemSum.setState(false);
    cbMenuItemAve.setState(false);
//    menuDisplay.addActionListener(new java.awt.event.ActionListener ()
//    {
//      public void actionPerformed(java.awt.event.ActionEvent evt)
//      {
//        menuDisplayActionPerformed(evt);
//      }
//    }
//    );
    cbMenuItemAll.addItemListener (new java.awt.event.ItemListener ()
    {
      public void itemStateChanged (java.awt.event.ItemEvent evt)
      {
        cbMenuItemAllItemStateChanged (evt);
      }
    }
    );
    cbMenuItemSum.addItemListener (new java.awt.event.ItemListener ()
    {
      public void itemStateChanged (java.awt.event.ItemEvent evt)
      {
        cbMenuItemSumItemStateChanged (evt);
      }
    }
    );
    cbMenuItemAve.addItemListener (new java.awt.event.ItemListener ()
    {
      public void itemStateChanged (java.awt.event.ItemEvent evt)
      {
        cbMenuItemAveItemStateChanged (evt);
      }
    }
    );
    menuDisplay.add(cbMenuItemAll);
    menuDisplay.add(cbMenuItemSum);
    menuDisplay.add(cbMenuItemAve);
    super.addToMenuBar(menuDisplay);
  }
  
//  private void menuDisplayActionPerformed(java.awt.event.ActionEvent e)
//  {
//    boolean stateAll = cbMenuItemAll.getState();
//    boolean stateSum = cbMenuItemSum.getState();
//    boolean stateAve = cbMenuItemAve.getState();
//  }
  
  private void updateTimeSeriesPlot(TimeSeries ts)
  {
    timeSeriesPlot.setTimeSeries(ts);
//    TimeSeriesPlot timeSeriesPlot = new TimeSeriesPlot(ts);
//    timeSeriesPlot.setLineState(super.checkboxMenuItemLines.getState());
//    timeSeriesPlot.setPointState(super.checkboxMenuItemPoints.getState());
//    timeSeriesPlot.setXLog(super.checkboxMenuItemXAxis.getState());
//    timeSeriesPlot.setYLog(super.checkboxMenuItemYAxis.getState());
    timeSeriesPlot.plotData();
    timeSeriesPlot.repaint();
//    showPlot(timeSeriesPlot);
//    useRelTime();
  }
  
  private void cbMenuItemAllItemStateChanged(java.awt.event.ItemEvent ie)
  {
    boolean state = cbMenuItemAll.getState();
    if (state)
    {
//      System.out.println("Yes, stateAll=" + stateAll);
      cbMenuItemSum.setState(false);
      cbMenuItemAve.setState(false);
      TimeSeries ts = timeSeries;
      updateTimeSeriesPlot(ts);
    }
    else
    {
//      System.out.println("No, stateAll=" + stateAll);
      cbMenuItemAll.setState(true);
    }
//    System.out.println("All=" + cbMenuItemAll.getState());
//    System.out.println("Sum=" + cbMenuItemSum.getState());
//    System.out.println("Ave=" + cbMenuItemAve.getState());
  }
  
  private void cbMenuItemSumItemStateChanged(java.awt.event.ItemEvent ie)
  {
    boolean state = cbMenuItemSum.getState();
    if (state)
    {
//      System.out.println("Yes, stateAll=" + stateAll);
      cbMenuItemAll.setState(false);
      cbMenuItemAve.setState(false);
      TimeSeries ts = timeSeries.sumFields();
      updateTimeSeriesPlot(ts);
    }
    else
    {
//      System.out.println("No, stateAll=" + stateAll);
      cbMenuItemSum.setState(true);
    }
//    System.out.println("All=" + cbMenuItemAll.getState());
//    System.out.println("Sum=" + cbMenuItemSum.getState());
//    System.out.println("Ave=" + cbMenuItemAve.getState());
  }
  
  private void cbMenuItemAveItemStateChanged(java.awt.event.ItemEvent ie)
  {
    boolean state = cbMenuItemAve.getState();
    if (state)
    {
//      System.out.println("Yes, stateAll=" + stateAll);
      cbMenuItemAll.setState(false);
      cbMenuItemSum.setState(false);
      TimeSeries ts = timeSeries.averageFields();
      updateTimeSeriesPlot(ts);
    }
    else
    {
//      System.out.println("No, stateAll=" + stateAll);
      cbMenuItemAve.setState(true);
    }
//    System.out.println("All=" + cbMenuItemAll.getState());
//    System.out.println("Sum=" + cbMenuItemSum.getState());
//    System.out.println("Ave=" + cbMenuItemAve.getState());
  }
  
  /**
  * @param args the command line arguments
  */
  public static void main (String args[]) {
    //Test code for stand alone application.
    Date[] l = {new Date(-1000L), new Date(0L), new Date(1000L), new Date(2000L), new Date(3000L)};
    double[][] d = {{0.0,1.3},{1.0,2.9},{4.0,8.3},{9.0,5.4},{16.0,5.1}};
    TimeSeries ts = new TimeSeries(l,new Jama.Matrix(d));
    ts.setShortDescription("This is a test!");
    SEAPlotFrame sea = new SEAPlotFrame(ts);
    sea.show();
  }

}