package saaps.sapm;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import ptolemy.plot.Plot;
//import saaps.sapm.anom001.SumKpNetwork;
import saaps.network.NetworkModel;
import saaps.network.NetworkParam;
import saaps.network.NormParam;
import saaps.util.TimeSeries;

public class AnomPredPlot
{
//	Date startDate;
//	Date endDate;
	
	Plot plot;
	
	public AnomPredPlot(NetworkParam netPar, NormParam normPar, TimeSeries tsIn)
	{
		//Create network model.
		NetworkModel nm = new NetworkModel(netPar,normPar);
		
		//Run network.
		TimeSeries ts = nm.sim(tsIn);
//		SumKpNetwork nn = new SumKpNetwork(tsIn);
		
		//Get the output.
//		TimeSeries ts = nn.getTS();
//		TimeSeries ts = tsIn;
		
		//Initialize plot.
		plot = new Plot();
		plot.setSize(400,300);
		plot.setButtons(true);

		//Generate data for test.
//		int x1 = (int) (startDate.getTime() / 1000 / 3600 / 24);
//		int x2 = (int) (endDate.getTime() / 1000 / 3600 / 24);
//		int l = x2 - x1 + 1;
//		double[] x = new double[l];
//		double[] y = new double[l];
//		for (int i=x1;i<=x2;i++)
//		{
//			x[i-x1] = (double) i;
//		  y[i-x1] = Math.sin(x[i-x1]);
//		  System.out.println("AnomPredPlot: x=" + x[i-x1] + " y=" + y[i-x1]);
//		}
		
		//Get first date in plot.
		Date d1 = ts.getDate(0);
		long l1 = d1.getTime();
		Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
		cal.setTime(d1);
		
		//Go through the objects in ts.
		boolean first = true;
		System.out.println("AnomPredPlot: ts.getLength()=" + ts.getLength());
		for (int i=0;i<ts.getLength();i++)
//		for (int i=0;i<x.length;i++)
		{
			System.out.println(ts.getDate(i));
			System.out.println(ts.getData(i,0));
			plot.addPoint(0, (double) (ts.getDate(i).getTime()-l1) / 1000 / 3600 /24 , ts.getData(i,0), !first);
//			plot.addPoint(0, x[i], y[i], !first);
			first = false;
		}
		
		//Set the axes.
		int year = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH)+1;
		int day = cal.get(Calendar.DATE);
		plot.setXLabel("Days from " + year + "-" + month + "-" + day);
//		plot.setXLabel("Days from " + cal.getTime() );
		plot.setYRange(-1,1);
	}
	
	public Plot getPlot()
	{
		return plot;
	}
}