/*
 * ElFluenceApp.java
 *
 * Created on June 20, 2001, 3:06 PM
 */

package saaps.sapm;

import java.awt.Dimension;
import java.awt.Font;

import java.util.Date;
import java.util.Calendar;
import java.util.TimeZone;

import java.net.MalformedURLException;

import saaps.sapm.ElFluence;
import saaps.util.*;

/**
 *
 * @author  leif
 * @version 
 */
public class ElFluenceApp extends java.awt.Panel {

    private AppHelp help = null;
    
    /** Creates new form ElFluenceApp */
    public ElFluenceApp(java.awt.Frame aFrame) {
        parentFrame = aFrame;
        initComponents ();
        init();
    }


  /** Initializes the applet ElFluenceApplet */
  public void init () {
    labelLoadingData.setFont(new Font("Helvetica",Font.BOLD,24));
    textFieldYellow.setText(String.valueOf(5e7));
    textFieldRed.setText(String.valueOf(5e8));
    setDateTextFields(new Date());
    panelPlot.add(labelLoadingData);
    pc = new PlotCreator();
    (new Thread(pc)).start();
    setSize(610,430);
  }

  class PlotCreator implements Runnable {
    Date plotDate;
    double yl;
    double rl;
    
    PlotCreator()
    {
      plotDate = new Date();
      yl = 5e7;
      rl = 5e8;
      elFluencePlot = new ElFluencePlot3(400,300);
    }
    
    public void setDate(Date d)
    {
      plotDate = d;
    }
    
    public Date getDate()
    {
      return plotDate;
    }
    
    public void setYellowLevel(double y)
    {
      yl = y;
    }
    
    public void setRedLevel(double r)
    {
      rl = r;
    }
    
    public void run()
    {
      getFluence(plotDate);
      setDateTextFields();
      elFluencePlot.setData(fluence,yl,rl,minY,maxY);
      panelPlot.remove(labelLoadingData);
//      panelPlot.add(elFluencePlot,new com.netbeans.developer.awt.AbsoluteConstraints (0, 0, 400, 200));
      panelPlot.add(elFluencePlot);
      elFluencePlot.repaint();
//     panelPlot.repaint();
//      elFluencePlot.setVisible(true);
//      elFluencePlot.validate();
//      repaint();
//      validate();
//      panelPlot.remove(labelLoadingData);
//      panelPlot.add(elFluencePlot,new com.netbeans.developer.awt.AbsoluteConstraints (20, 20, -1, -1));
//      panelPlot.validate();
    }
  }
    
  private void getFluence(Date d) {
      fluence = (new ElFluence(d)).getFluence();
  }
  
  private void setDateTextFields(Date d) {
    cal.setTime(d);
    textFieldYear.setText(String.valueOf(cal.get(cal.YEAR)));
    textFieldMonth.setText(String.valueOf(cal.get(cal.MONTH)+1));
    textFieldDate.setText(String.valueOf(cal.get(cal.DATE)));
  }
  
  private void setDateTextFields() {
    Date d = fluence.getLastDate();
    setDateTextFields(d);
//    cal.setTime(d);
//    textFieldYear.setText(String.valueOf(cal.get(cal.YEAR)));
//    textFieldMonth.setText(String.valueOf(cal.get(cal.MONTH)+1));
//    textFieldDate.setText(String.valueOf(cal.get(cal.DATE)));
  }
  
  private double getTextFieldValue(java.awt.TextField tf)
  {
    double value = 0;
    try
    {
      value = Double.valueOf(tf.getText()).doubleValue();
    }
    catch(NumberFormatException nfe)
    {
      System.err.println(nfe);
    }
    return value;
  }
    
  public void setDefaultLevels()
  {
    textFieldYellow.setText(Double.toString(5e7));
    textFieldRed.setText(Double.toString(5e8));
  }
  
  public void drawLevels()
  {
    try
    {
      double levelRed = Double.valueOf(textFieldRed.getText()).doubleValue();
      double levelYellow = Double.valueOf(textFieldYellow.getText()).doubleValue();
      //Make sure that the red level is always higher than the yellow level.
      if(levelRed<levelYellow)
      {
        levelRed = levelYellow;
        textFieldRed.setText(Double.toString(levelRed));
      }
      elFluencePlot.setYellowLevel(levelYellow);
      elFluencePlot.setRedLevel(levelRed);
      elFluencePlot.repaint();
    }
    catch(NumberFormatException nfe)
    {
      System.err.println(nfe);
    }
  }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
  private void initComponents() {//GEN-BEGIN:initComponents
      label3 = new java.awt.Label();
      buttonHelp = new java.awt.Button();
      buttonQuit = new java.awt.Button();
      panelLeft = new java.awt.Panel();
      label4 = new java.awt.Label();
      label5 = new java.awt.Label();
      textFieldRed = new java.awt.TextField();
      label6 = new java.awt.Label();
      textFieldYellow = new java.awt.TextField();
      buttonDefault = new java.awt.Button();
      label7 = new java.awt.Label();
      textFieldYear = new java.awt.TextField();
      label8 = new java.awt.Label();
      textFieldMonth = new java.awt.TextField();
      label9 = new java.awt.Label();
      textFieldDate = new java.awt.TextField();
      buttonToday = new java.awt.Button();
      buttonPlot = new java.awt.Button();
      panelPlot = new java.awt.Panel();
      
      setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints1;
      
      label3.setFont(new java.awt.Font("Dialog", 1, 18));
      label3.setName("label6");
      label3.setBackground(java.awt.Color.lightGray);
      label3.setForeground(java.awt.Color.black);
      label3.setText("24 hour fluence of GOES-8 >2 MeV electrons");
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.gridwidth = 2;
      gridBagConstraints1.insets = new java.awt.Insets(10, 0, 0, 0);
      add(label3, gridBagConstraints1);
      
      buttonHelp.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonHelp.setLabel("Help");
      buttonHelp.setName("button5");
      buttonHelp.setBackground(new java.awt.Color(204, 204, 204));
      buttonHelp.setForeground(java.awt.Color.black);
      buttonHelp.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonHelpActionPerformed(evt);
          }
      });
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 3;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.insets = new java.awt.Insets(10, 50, 0, 0);
      add(buttonHelp, gridBagConstraints1);
      
      buttonQuit.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonQuit.setLabel("Quit");
      buttonQuit.setName("button9");
      buttonQuit.setBackground(new java.awt.Color(204, 204, 204));
      buttonQuit.setForeground(java.awt.Color.black);
      buttonQuit.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonQuitActionPerformed(evt);
          }
      });
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.insets = new java.awt.Insets(10, 20, 0, 10);
      add(buttonQuit, gridBagConstraints1);
      
      panelLeft.setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints2;
      
      panelLeft.setFont(new java.awt.Font("Dialog", 0, 11));
      panelLeft.setName("panel15");
      panelLeft.setBackground(new java.awt.Color(204, 204, 204));
      panelLeft.setForeground(java.awt.Color.black);
      label4.setFont(new java.awt.Font("Dialog", 0, 11));
      label4.setName("label7");
      label4.setBackground(java.awt.Color.lightGray);
      label4.setForeground(java.awt.Color.black);
      label4.setText("Threshold levels");
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 10, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label4, gridBagConstraints2);
      
      label5.setFont(new java.awt.Font("Dialog", 0, 11));
      label5.setName("label8");
      label5.setBackground(java.awt.Color.lightGray);
      label5.setForeground(java.awt.Color.black);
      label5.setText("Red");
      label5.setAlignment(java.awt.Label.RIGHT);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label5, gridBagConstraints2);
      
      textFieldRed.setText("5.0E8");
      textFieldRed.setBackground(new java.awt.Color(255, 247, 233));
      textFieldRed.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldRed.setForeground(java.awt.Color.black);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 1;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(textFieldRed, gridBagConstraints2);
      
      label6.setFont(new java.awt.Font("Dialog", 0, 11));
      label6.setName("label9");
      label6.setBackground(java.awt.Color.lightGray);
      label6.setForeground(java.awt.Color.black);
      label6.setText("Yellow");
      label6.setAlignment(java.awt.Label.RIGHT);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label6, gridBagConstraints2);
      
      textFieldYellow.setText("5.0E7");
      textFieldYellow.setBackground(new java.awt.Color(255, 247, 233));
      textFieldYellow.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldYellow.setForeground(java.awt.Color.black);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 2;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(textFieldYellow, gridBagConstraints2);
      
      buttonDefault.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonDefault.setLabel("Default levels");
      buttonDefault.setName("button6");
      buttonDefault.setBackground(new java.awt.Color(204, 204, 204));
      buttonDefault.setForeground(java.awt.Color.black);
      buttonDefault.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonDefaultActionPerformed(evt);
          }
      });
      
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.gridwidth = 2;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 50, 0);
      panelLeft.add(buttonDefault, gridBagConstraints2);
      
      label7.setFont(new java.awt.Font("Dialog", 0, 11));
      label7.setName("label10");
      label7.setBackground(java.awt.Color.lightGray);
      label7.setForeground(java.awt.Color.black);
      label7.setText("Year");
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label7, gridBagConstraints2);
      
      textFieldYear.setText("2000");
      textFieldYear.setBackground(new java.awt.Color(255, 247, 233));
      textFieldYear.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldYear.setForeground(java.awt.Color.black);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 4;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(textFieldYear, gridBagConstraints2);
      
      label8.setFont(new java.awt.Font("Dialog", 0, 11));
      label8.setName("label11");
      label8.setBackground(java.awt.Color.lightGray);
      label8.setForeground(java.awt.Color.black);
      label8.setText("Month");
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label8, gridBagConstraints2);
      
      textFieldMonth.setText("12");
      textFieldMonth.setBackground(new java.awt.Color(255, 247, 233));
      textFieldMonth.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldMonth.setForeground(java.awt.Color.black);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 5;
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(textFieldMonth, gridBagConstraints2);
      
      label9.setFont(new java.awt.Font("Dialog", 0, 11));
      label9.setName("label12");
      label9.setBackground(java.awt.Color.lightGray);
      label9.setForeground(java.awt.Color.black);
      label9.setText("Date");
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(label9, gridBagConstraints2);
      
      textFieldDate.setText("01");
      textFieldDate.setBackground(new java.awt.Color(255, 247, 233));
      textFieldDate.setFont(new java.awt.Font("Dialog", 0, 11));
      textFieldDate.setForeground(java.awt.Color.black);
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 6;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(textFieldDate, gridBagConstraints2);
      
      buttonToday.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonToday.setLabel("Today");
      buttonToday.setName("button7");
      buttonToday.setBackground(new java.awt.Color(204, 204, 204));
      buttonToday.setForeground(java.awt.Color.black);
      buttonToday.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonTodayActionPerformed(evt);
          }
      });
      
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridx = 0;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(buttonToday, gridBagConstraints2);
      
      buttonPlot.setFont(new java.awt.Font("Dialog", 0, 11));
      buttonPlot.setLabel("Plot");
      buttonPlot.setName("button8");
      buttonPlot.setBackground(new java.awt.Color(204, 204, 204));
      buttonPlot.setForeground(java.awt.Color.black);
      buttonPlot.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(java.awt.event.ActionEvent evt) {
              buttonPlotActionPerformed(evt);
          }
      });
      
      gridBagConstraints2 = new java.awt.GridBagConstraints();
      gridBagConstraints2.gridy = 7;
      gridBagConstraints2.insets = new java.awt.Insets(0, 0, 20, 0);
      gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
      panelLeft.add(buttonPlot, gridBagConstraints2);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets(0, 10, 10, 5);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(panelLeft, gridBagConstraints1);
      
      panelPlot.setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints3;
      
      panelPlot.setFont(new java.awt.Font("Dialog", 0, 11));
      panelPlot.setName("panel27");
      panelPlot.setBackground(new java.awt.Color(204, 204, 204));
      panelPlot.setForeground(java.awt.Color.black);
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridwidth = 4;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.insets = new java.awt.Insets(0, 5, 10, 10);
      add(panelPlot, gridBagConstraints1);
      
  }//GEN-END:initComponents

  private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
      if(help != null)
          help.dispose();

      parentFrame.dispose();
      //System.exit(0);
  }//GEN-LAST:event_buttonQuitActionPerformed

  private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
      System.out.println("Launching help frame ...");
      if(help != null) {
          help.setVisible(true);
      }
      else {
        /* Get a Class object from this object and then the Name of the class to use as help fi */
          help = AppHelp.getAppHelp(this.getClass().getName());
      }
  }//GEN-LAST:event_buttonHelpActionPerformed

  private void buttonPlotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonPlotActionPerformed
    try
    {
      int year = Integer.valueOf(textFieldYear.getText()).intValue();
      int month = Integer.valueOf(textFieldMonth.getText()).intValue()-1;
      int date = Integer.valueOf(textFieldDate.getText()).intValue();
      cal.setTime(pc.getDate());
      //If dates have not changed just redraw the levels.
      if(cal.get(cal.YEAR)==year & cal.get(cal.MONTH)==month & cal.get(cal.DATE)==date)
      {
        drawLevels();
      }
      //If new dates load new data.
      else
      {
        panelPlot.remove(elFluencePlot);
        panelPlot.add(labelLoadingData);
        cal.set(cal.YEAR,year);
        cal.set(cal.MONTH,month);
        cal.set(cal.DATE,date);
        cal.set(cal.HOUR_OF_DAY,23);
        cal.set(cal.MINUTE,59);
        double levelRed = Double.valueOf(textFieldRed.getText()).doubleValue();
        double levelYellow = Double.valueOf(textFieldYellow.getText()).doubleValue();
        pc.setDate(cal.getTime());
        pc.setYellowLevel(levelYellow);
        pc.setRedLevel(levelRed);
        (new Thread(pc)).start();
      }
    }
    catch(NumberFormatException nfe)
    {
      System.err.println(nfe);
    }
  }//GEN-LAST:event_buttonPlotActionPerformed

  private void buttonTodayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonTodayActionPerformed
    setDateTextFields(new Date());
    repaint();
  }//GEN-LAST:event_buttonTodayActionPerformed

  private void buttonDefaultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonDefaultActionPerformed
    setDefaultLevels();
    drawLevels();
  }//GEN-LAST:event_buttonDefaultActionPerformed

    public static void main(java.lang.String[] args) {
      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
                    /** Exit the Application */
              myFrame.dispose();
              System.exit (0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color (204, 204, 204));
      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      myFrame.setName("ElFluence");
      myFrame.setTitle("ElFluence");
      myFrame.add(new ElFluenceApp(myFrame),gridBagConstraints1);
      myFrame.pack();
      myFrame.show();
  }

  public static void getElFluenceApp() {
      final java.awt.Frame myFrame = new java.awt.Frame();
      myFrame.addWindowListener(new java.awt.event.WindowAdapter() {
          public void windowClosing(java.awt.event.WindowEvent evt) {
                    /** Exit the Application */
              myFrame.dispose();
              System.exit (0);
          }
      }
      );
      myFrame.setBackground(new java.awt.Color (204, 204, 204));
      myFrame.setLayout(new java.awt.GridBagLayout());
      //Setup constraints for filling out SEAApp panel
      java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      myFrame.setName("ElFluence");
      myFrame.setTitle("ElFluence");
      myFrame.add(new ElFluenceApp(myFrame),gridBagConstraints1);
      myFrame.pack();
      myFrame.show();
  }
  
  private java.awt.Frame parentFrame;
  //The electron fluence.
  TimeSeries fluence;
  //The electron fluence plot.
  private ElFluencePlot3 elFluencePlot;
  //Calendar for UT time.
  Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
  //The minimum and maximum values of the y-axis.
  private double minY = 1e5;
  private double maxY = 1e9;
  //The data loading info.
  private java.awt.Label labelLoadingData = new java.awt.Label("Loading data ...", java.awt.Label.CENTER);
  //The object for creating the plot.
  private PlotCreator pc;
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private java.awt.Label label3;
  private java.awt.Button buttonHelp;
  private java.awt.Button buttonQuit;
  private java.awt.Panel panelLeft;
  private java.awt.Label label4;
  private java.awt.Label label5;
  private java.awt.TextField textFieldRed;
  private java.awt.Label label6;
  private java.awt.TextField textFieldYellow;
  private java.awt.Button buttonDefault;
  private java.awt.Label label7;
  private java.awt.TextField textFieldYear;
  private java.awt.Label label8;
  private java.awt.TextField textFieldMonth;
  private java.awt.Label label9;
  private java.awt.TextField textFieldDate;
  private java.awt.Button buttonToday;
  private java.awt.Button buttonPlot;
  private java.awt.Panel panelPlot;
  // End of variables declaration//GEN-END:variables

}
