/*
 * ElFluencePlot.java
 *
 * Created on November 21, 2000, 4:14 PM
 */
 
package saaps.sapm;

import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

import saaps.util.TimeSeries;

/** 
 *
 * @author  saaps
 * @version 
 */
public class ElFluencePlot extends saaps.util.TimeSeriesPlot {

  //The red and yellow levels.
  private double levelRed;
  private double levelYellow;
  
  /** Creates new ElFluencePlot */
  public ElFluencePlot(TimeSeries ts,double lr,double ly) {
    super(ts);
    setYRange(1e6,1e9);
    setYLog(true);
    setZeroTime(thisDay(ts.getLastDate()));
    plotData();
    repaint();
    levelRed = lr;
    levelYellow = ly;
  }
  
  private Date thisDay(Date d)
  {
    Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
    cal.setTime(d);
    cal.set(Calendar.HOUR_OF_DAY,0);
    cal.set(Calendar.MINUTE,0);
    cal.set(Calendar.SECOND,0);
    cal.set(Calendar.MILLISECOND,0);
    return cal.getTime();
  }
}