PRO sedat_read_record_odi, meta, srec, nrec, data, status

  status = 0

  ;DBConnect, oDB

  oDB = meta.odi_db

  query = "SELECT id, name, epoch_start AS tmin, " + $
          "epoch_end AS tmax " + $
          "FROM dataset WHERE " + $
          "sedat_name='" + STRMID(meta.name, 7) + "'"
  oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
  dataset = oRS->GetRecord()
  OBJ_DESTROY, oRS

  vardesc = {odi_vard, index: 0L, dtype: '', vtype: '', ndims: 0L, dimensions: LONARR(10)}
  nvar = meta.n_vars
  vardesc = REPLICATE(vardesc, nvar)

  nv = 0L
  FOR i=0L,nvar-1 DO BEGIN
    query = "SELECT id, record_variance FROM variable_metadata WHERE dataset_id=" + $
            STRING(dataset.id) + " AND UPPER(name)='" + STRUPCASE(meta.var.(i).name) + "'"
    oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
    rec = oRS->GetRecord()
    id = rec.id
    rvariance = rec.record_variance
    OBJ_DESTROY, oRS

    IF (rvariance EQ 'F') THEN BEGIN
      query = "SELECT LEFT(nrv_value, 500) AS value FROM variable_nrv WHERE " + $
              "variable_metadata_id=" + STRING(id) + " ORDER BY nrv_index"
      oRS = OBJ_NEW('IDLDBRecordSet', oDB, SQL=query)
      rec = oRS->GetRecord()
      nrv = [rec.value]
      WHILE (oRS->MoveCursor(/NEXT)) DO BEGIN
        rec = oRS->GetRecord()
        nrv = [nrv, rec.value]
      ENDWHILE
      OBJ_DESTROY, oRS
      data.(i) = cast_odi(STRTRIM(nrv, 2), meta.var.(i).datatype)
    ENDIF ELSE BEGIN
      vdim = LONARR(10)
      vdim[0:meta.var.(i).n_dims-1] = meta.var.(i).dimensions
      vardesc[nv] = {odi_vard, i, meta.var.(i).datatype, '', meta.var.(i).n_dims, vdim}
      nv = nv + 1
    ENDELSE
  ENDFOR

; Construct the query
  query = "SELECT cdf_epoch AS epoch"
  FOR i=0,nv-1 DO BEGIN
    vname = STRLOWCASE(meta.var.(vardesc[i].index).name)
    IF (vname NE "epoch") THEN BEGIN
      IF (vardesc[i].ndims EQ 1) THEN BEGIN
        IF (vardesc[i].dimensions[0] EQ 1) THEN BEGIN
          query = query + ", CAST(" + vname + " AS CHAR) AS " + vname
        ENDIF ELSE BEGIN
          FOR j=1,vardesc[i].dimensions[0] DO BEGIN
            qvname = vname + "_" + STRTRIM(STRING(j), 2)
            query = query + ", CAST(" + qvname + " AS CHAR) AS " + qvname
          ENDFOR
        ENDELSE
      ENDIF
    ENDIF
  ENDFOR
  query = query + " FROM " + dataset.name + " LIMIT " + STRING(srec-1) + "," + STRING(nrec)
;  query = "SELECT * FROM " + dataset.name + " LIMIT " + STRING(srec-1) + "," + STRING(nrec)


  oRS = OBJ_NEW('IDLDBRecordSet', oDB, N_BUFFERS=10000L, SQL=query)
  nf = oRS->NFields()
  status = oRS->MoveCursor(/FIRST)
  rec = oRS->GetRecord()
  rec = REPLICATE(rec, nrec)

  FOR i=2L,nrec DO BEGIN
    rec[i-1] = oRS->GetRecord()
    status = oRS->MoveCursor(/NEXT)
  ENDFOR
  OBJ_DESTROY, oRS

; Load the raw data from the database retrieved records into the required SEDAT dataset structure format:
  nr = 0L
  nfields = n_tags( data)
  for itag=0, nv-1 DO BEGIN
      ifield = vardesc[itag].index   ; get the structure field index for the varying fields (non varying fields have been processed)
      FOR idim=0,meta.var.(ifield).dimensions[0]-1 DO BEGIN   ; loop over the dimensions of the data field
          data[*].(ifield)[idim] = rec.(nr)
          nr++  ; move on to the next field in the SQL dataset record
      ENDFOR
  ENDFOR

;  nr = -1 ; field in the record structure
;  FOR j=0,nv-1 DO BEGIN
;    FOR k=1,meta.var.(vardesc[j].index).dimensions[0] DO BEGIN
;      nr = nr + 1
;       data[i-1].(vardesc[j].index)[k-1] = oRS->GetField(nr, NULL_VALUE=meta.var.(vardesc[j].index).null)
;      data[i-1].(vardesc[j].index)[k-1] =  rec.(nr)
;    ENDFOR
;  ENDFOR


END
