#!/usr/bin/php
<?php
/**
* A program to install the cron jobs from the cronjobs.txt file.
* Environment variables are expanded before installed on cron.
*
* @author Peter Wintoft
* @version 1.0
*/

$home = getenv("HOME");

$cron_jobs = file("cronjobs.txt");

$cron_file_name = "cronjobs.tmp";

$cron_file = fopen($cron_file_name,"w");

foreach($cron_jobs as $job) {
    $job = trim($job);
    // Skip lines starting with #.
    if(preg_match('/^#/',$job)==0 & strlen($job)>10) {
        $cron_line = trim(preg_replace('/\$HOME/',$home,$job));
        fwrite($cron_file,$cron_line."\n");
    }
}

fclose($cron_file);

exec('crontab '.$cron_file_name);
unlink($cron_file_name);

fwrite(STDOUT,"Installed the following cron jobs:\n");
exec('crontab -l',$res);
foreach($res as $r) {
    fwrite(STDOUT,$r."\n");
}

?>