#!/usr/bin/php
<?php

  require_once($_SERVER["ODI_HOME"]."/lib/odi.library.php");

  require_once($_SERVER["ODI_HOME"]."/lib/odi.parsers.php");

  $rawdir = getenv("ODI_RAWDATA");
  if ($rawdir === FALSE)
  {
    print "  Environment variable ODI_RAWDATA not set!" . LF;
    exit;
  }

// Strip the command line arguments of the first entry, i.e. the script name
  array_shift($argv);

  print "Adding or updating data sets ..." . LF;
// Connect to the database at user level 3.
  $conn_array = get_conn_array(1);
  $conn = connect_to_database_array($conn_array);

  $entries = file("datasets.txt");

  foreach ($entries as $entry)
  {
    $args = explode(";;;", $entry);
    $process = FALSE;
    if (in_array(trim($args[0], "# "), $argv))
      $process = TRUE;
    else
      if ((substr($entry, 0, 1) != "#") && (count($argv) == 0))
        $process = TRUE;

    if ($process)
    {
      $dataset_name = "dataset_" . trim($args[0], "# ");
      $basedir = $rawdir . trim($args[1]) . "/";
      $filepattern = trim($args[2]);
      $platform = trim($args[3]);
      $platform_type = trim($args[4]);
      $instrument = trim($args[5]);
      $sk_file = trim($args[6]);
      $sedat_name = trim($args[7]);
      $sedat_regions = trim($args[8]);
      $sedat_particles = trim($args[9]);
      $sedat_emin = trim($args[10]);
      $sedat_emax = trim($args[11]);

      chdir($platform);
// Check if the dataset already exists.
      if (!exists_dataset($conn, $dataset_name))
      {
        skt2odi($conn, $dataset_name, $platform, $platform_type, $instrument, $sk_file,
                $sedat_name, $sedat_regions, $sedat_particles, $sedat_emin, $sedat_emax);
      }

      print "   Processing " . $dataset_name . " ..." . LF; 

      $nf = ingest_data($conn, $dataset_name, $basedir, $platform, $instrument, $filepattern, $sk_file);
      if ($nf > 0) print "      " . $nf . " files updated or added for " . $dataset_name . LF;
      chdir("../");
    }
  }

  mysqli_close($conn);

?>