#!/usr/bin/php
<?php
// Delete the data and metadata for a selected dataset.
// Peter Wintoft, Swedish Institute of Space Physics
// 2009-09-04

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Get the input arguments.
$arg_array=array("sedat_name");
$args=get_cl_arguments($argv,$arg_array);

// Connect to the database at user level 1.
$conn_array=get_conn_array(1);
$conn=connect_to_database_array($conn_array);

// Check that the dataset exists and count the number of records, variables, ... that will be deleted.
$q = 'SELECT * FROM dataset WHERE sedat_name='.quote($args["sedat_name"]);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
if($row=$res->fetch_assoc()) {
    fwrite(STDOUT,"===================\n".$args["sedat_name"]."\n------------\n");
    foreach($row as $key=>$value)
        fwrite(STDOUT,$key." = ".$value."\n");
    $dataset_id=$row["id"];
    $dataset_table=$row["name"];
    // Get number of global metadata.
    $q = 'SELECT COUNT(*) FROM dataset_metadata WHERE dataset_id='.$dataset_id;
    if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
    $row=$res->fetch_array();
    fwrite(STDOUT,"Number of global metadata: ".$row[0]."\n");
    // Get number of variables.
    $q = 'SELECT COUNT(*) FROM variable_metadata WHERE dataset_id='.$dataset_id;
    if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
    $row=$res->fetch_array();
    fwrite(STDOUT,"Number of variables: ".$row[0]."\n");
    // Get number of records.
    $q = 'SELECT COUNT(*) FROM '.$dataset_table;
    if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
    $row=$res->fetch_array();
    fwrite(STDOUT,"Number of records: ".$row[0]."\n");
    // Query if to delete.
    fwrite(STDOUT," Delete? (y/[n]): ");
    $input=trim(fgets(STDIN));
    if($input=='y') {
        fwrite(STDOUT,"Deleting ".$args["sedat_name"]." ... ");
        $q = 'DROP TABLE '.$dataset_table;
        if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
        $q = 'DELETE FROM dataset WHERE id='.$dataset_id;
        if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
        fwrite(STDOUT,"Done!\n");
    }
    else {
        fwrite(STDOUT,"Will not delete!\n");
    }
}
else {
    fwrite(STDOUT,$args["sedat_name"]." does not exist!\n");
    exit(0);
}
?>
