#!/usr/bin/php
<?php
/**
* Create a template XML file to be used with the export_to_text program.
*
* @author Peter Wintoft <peter@lund.irf.se>
* @version 1.0
*/

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Get the input arguments.
$arg_array=array("dataset");
$args=get_cl_arguments($argv,$arg_array);
$dataset=$args["dataset"];

// Connect to the database at user level 3.
$conn_array=get_conn_array(3);
$conn=connect_to_database_array($conn_array);

// Open the XML output file.
$file_name = $dataset.".set.xml";
$file = fopen($file_name,"w");

// XML head.
fwrite($file,'<?xml version="1.0"?>'.LF);
fwrite($file,'<odi>'.LF);
fwrite($file,"<creator>Your Name (email)</creator>".LF);
fwrite($file,"<export_file>".$dataset.".xml</export_file>".LF);
fwrite($file,"<dataset>".$dataset."</dataset>".LF);

// Get the end epoch. Set start epoch = end epoch - one day.
$q = "SELECT epoch_end FROM dataset WHERE sedat_name=".quote($dataset);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
if ($row=$res->fetch_assoc()) {
    $epoch_end_cdf = $row["epoch_end"];
}
else {
    fwrite(STDOUT,"Dataset does not exist, or no data in dataset: ".$dataset.LF);
    exit;
}
$epoch_start_cdf = $epoch_end_cdf - 24*60*60*1000;
list($epoch_start,$ms_start) = cdfepoch_to_date($epoch_start_cdf);
fwrite($file,"<epoch_start>".$epoch_start.".".$ms_start."</epoch_start>".LF);
list($epoch_end,$ms_end) = cdfepoch_to_date($epoch_end_cdf);
fwrite($file,"<epoch_end>".$epoch_end.".".$ms_end."</epoch_end>".LF);

fwrite($file,"<max_num_rec>1000</max_num_rec>".LF);

// Get the variable names for this dataset.
$q = "SELECT vm.name AS name FROM variable_metadata AS vm";
$q.= " LEFT JOIN dataset AS ds ON vm.dataset_id=ds.id";
$q.= " WHERE vm.record_variance='T'";
$q.= " AND ds.sedat_name=".quote($dataset);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
while($row=$res->fetch_assoc()) {
    fwrite($file,"<variable>".$row["name"]."</variable>".LF);
}

fwrite($file,'</odi>'.LF);

// Close XML file.
fclose($file);

?>