#!/usr/bin/php
<?php
/**
* Get the SEDAT name, ODI name and epoch range for a selected dataset.
*
* Usage: show_datasets.php [<dataset>]
*
* @author Peter Wintoft, Swedish Institute of Space Physics
* @version 1.0
*/

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Get the input arguments.
$dataset="%";
if(count($argv)>1) {
    $dataset=$argv[1];
}
elseif(count($argv)>2) {
    fwrite(STDOUT,"Error: To many input arguments.\n");
    fwrite(STDOUT,"Usage: show_datasets.php [<dataset>].\n");
}

// Connect to the database at user level 3.
$conn_array=get_conn_array(3);
$conn=connect_to_database_array($conn_array);

// Get the epoch range.
//$q = 'SELECT MIN(epoch) AS t1, MAX(epoch) AS t2 FROM '.no_quote($args["dataset"]);
$q = 'SELECT name,sedat_name,epoch_start,epoch_end FROM dataset WHERE sedat_name LIKE '.quote($dataset);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
while($row=$res->fetch_assoc()) {
    fwrite(STDOUT,$row["sedat_name"]." (".$row["name"].") ");
    $q = 'SELECT COUNT(cdf_epoch) AS num_rec FROM '.$row["name"];
    if (!($res_count=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
    $count = $res_count->fetch_assoc();
    fwrite(STDOUT,$count["num_rec"]." records: ");
    if($row["epoch_start"]) {
        list($date,$ms) = cdfepoch_to_date($row["epoch_start"]);
        fwrite(STDOUT,$date.".".str_pad($ms,3,"0",STR_PAD_LEFT)." to ");
        list($date,$ms) = cdfepoch_to_date($row["epoch_end"]);
        fwrite(STDOUT,$date.".".str_pad($ms,3,"0",STR_PAD_LEFT)."\n");
    }
    else {
        fwrite(STDOUT,"No data!\n");
    }
}

?>