#!/usr/bin/php
<?php
// Show the metadata for a selected dataset.
// Peter Wintoft, Swedish Institute of Space Physics
// 2009-05-14

require_once($_SERVER["ODI_HOME"].'/lib/odi.library.php');

// Get the input arguments.
$arg_array=array("dataset");
$args=get_cl_arguments($argv,$arg_array);

// Connect to the database at user level 3.
$conn_array=get_conn_array(3);
$conn=connect_to_database_array($conn_array);

// Get the "dataset" metadata.
$q = 'SELECT * FROM dataset WHERE sedat_name='.quote($args["dataset"]);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
if($row=$res->fetch_assoc()) {
    fwrite(STDOUT,"===================\n".$args["dataset"]."\n------------\n");
    foreach($row as $key=>$value)
        fwrite(STDOUT,$key." = ".$value."\n");
}
else {
    fwrite(STDOUT,$args["dataset"]." does not exist!\n");
    exit(0);
}

// Get the "dataset_metadata".
$q = 'SELECT attribute, cdf_type, entry_number, value';
$q.= ' FROM dataset_metadata';
$q.= ' LEFT JOIN dataset ON dataset_metadata.dataset_id=dataset.id';
$q.= ' LEFT JOIN data_type ON dataset_metadata.data_type_id=data_type.id';
$q.= ' WHERE dataset.sedat_name='.quote($args["dataset"]);
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
fwrite(STDOUT,"----------------\nGlobal attributes\n----------------\n");
while($row=$res->fetch_assoc()) {
    foreach($row as $key=>$value) {
        fwrite(STDOUT,$key." = ".$value."\n");
    }
    fwrite(STDOUT,"----------------\n");
}

// Get the "variable_metadata".
$q = 'SELECT data_type.cdf_type AS data_type,';
$q .= ' variable_metadata.name AS name';
$q .= ' FROM dataset JOIN variable_metadata JOIN data_type';
$q .= ' ON dataset.sedat_name='.quote($args["dataset"]);
$q .= ' AND variable_metadata.dataset_id = dataset.id';
$q .= ' AND variable_metadata.data_type_id = data_type.id';
$q .= ' ORDER BY name';
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
fwrite(STDOUT,"----------------\nVariables\n----------------\n");
while($row=$res->fetch_assoc()) {
    fwrite(STDOUT,$row["name"]." ".$row["data_type"]."\n");
}

// Get the "variable_attribute".
$q = 'SELECT variable_metadata.name AS var_name';
$q .= ',variable_attribute.name AS att_name';
$q .= ',variable_attribute.value AS value';
$q .= ' FROM dataset JOIN variable_metadata JOIN variable_attribute';
$q .= ' ON dataset.sedat_name='.quote($args["dataset"]);
$q .= ' AND variable_metadata.dataset_id = dataset.id';
$q .= ' AND variable_attribute.variable_metadata_id = variable_metadata.id';
$q .= ' ORDER BY var_name,att_name';
if (!($res=$conn->query($q))) printf("Query: %s\nError: %s\n",$q,$conn->error);
fwrite(STDOUT,"----------------\nVariable attributes\n----------------\n");
while($row=$res->fetch_assoc()) {
    fwrite(STDOUT,$row["var_name"]." ".$row["att_name"]." ".$row["value"]."\n");
}
?>